--- old/bootadm/bootadm.c	2012-08-31 05:08:45.067622085 +0400
+++ new/bootadm/bootadm.c	2012-08-31 05:08:45.155548371 +0400
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2012 Milan Jurik. All rights reserved.
+ * Copyright 2012 Daniil Lunev. All rights reserved.
  */
 
 /*
@@ -118,8 +119,8 @@
 
 #define	GRUB_DIR		"/boot/grub"
 #define	GRUB_STAGE2		GRUB_DIR "/stage2"
-#define	GRUB_MENU		"/boot/grub/menu.lst"
-#define	MENU_TMP		"/boot/grub/menu.lst.tmp"
+#define	GRUB_MENU		"/boot/illumos.cfg"
+#define	MENU_TMP		"/boot/illumos.cfg.tmp"
 #define	GRUB_BACKUP_MENU	"/etc/lu/GRUB_backup_menu"
 #define	RAMDISK_SPECIAL		"/ramdisk"
 #define	STUBBOOT		"/stubboot"
@@ -178,20 +179,21 @@
  * menu_cmd_t and menu_cmds must be kept in sync
  */
 char *menu_cmds[] = {
-	"default",	/* DEFAULT_CMD */
+	"default_entry",/* DEFAULT_CMD */
 	"timeout",	/* TIMEOUT_CMD */
-	"title",	/* TITLE_CMD */
-	"root",		/* ROOT_CMD */
-	"kernel",	/* KERNEL_CMD */
-	"kernel$",	/* KERNEL_DOLLAR_CMD */
-	"module",	/* MODULE_CMD */
-	"module$",	/* MODULE_DOLLAR_CMD */
-	" ",		/* SEP_CMD */
+	"entry_name",	/* TITLE_CMD */
+	"pool_uuid",	/* ROOT_CMD */
+	"kernel_path$",	/* KERNEL_CMD */
+	"kernel_path",	/* KERNEL_DOLLAR_CMD */
+	"module$",	/* MODULE_CMD */
+	"module",	/* MODULE_DOLLAR_CMD */
+	"=",		/* SEP_CMD */
 	"#",		/* COMMENT_CMD */
 	"chainloader",	/* CHAINLOADER_CMD */
 	"args",		/* ARGS_CMD */
-	"findroot",	/* FINDROOT_CMD */
-	"bootfs",	/* BOOTFS_CMD */
+	"pool_label",	/* FINDROOT_CMD */
+	"data_set",	/* BOOTFS_CMD */
+	"kernel_options",/* KERNEL_OPTIONS_CMD */
 	NULL
 };
 
@@ -4690,6 +4692,7 @@
 	menu_cmd_t	k_cmd;
 	menu_cmd_t	m_cmd;
 	const char	*fcn = "add_boot_entry()";
+	char * options = NULL;
 
 	assert(mp);
 
@@ -4756,10 +4759,21 @@
 		line_parser(mp, linebuf, &lineNum, &entryNum);
 	}
 
-	(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s",
-	    menu_cmds[k_cmd], menu_cmds[SEP_CMD], kernel);
+	options = strpbrk(kernel, " \t");
+	if (options)
+		++options;
+
+	(void) snprintf(linebuf, sizeof (linebuf), "%s%s",
+	    menu_cmds[k_cmd], menu_cmds[SEP_CMD]);
+	(void) strncat(linebuf, kernel, options - kernel);
 	line_parser(mp, linebuf, &lineNum, &entryNum);
 
+	if (options) {
+		(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s",
+		    menu_cmds[KERNEL_OPTIONS_CMD], menu_cmds[SEP_CMD], options);
+		line_parser(mp, linebuf, &lineNum, &entryNum);
+	}
+
 	if (mod_kernel != NULL) {
 		(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s",
 		    menu_cmds[m_cmd], menu_cmds[SEP_CMD], mod_kernel);
@@ -7112,18 +7126,19 @@
 	slice = strrchr(osdev, 's');
 
 	grubsign = s_calloc(1, MAXNAMELEN + 10);
-	if (slice) {
+/*	if (slice) {
 		(void) snprintf(grubsign, MAXNAMELEN + 10, "(%s,%d,%c)",
 		    sign, fdiskpart, slice[1] + 'a' - '0');
 	} else
 		(void) snprintf(grubsign, MAXNAMELEN + 10, "(%s,%d)",
-		    sign, fdiskpart);
+		    sign, fdiskpart);*/
+	grubsign = strdup(sign);
 
 	free(sign);
 
 	BAM_DPRINTF((D_GET_GRUBSIGN_SUCCESS, fcn, grubsign));
 
-	return (grubsign);
+	return (strchr(grubsign,'_') + 1);
 }
 
 static char *
@@ -7812,7 +7827,7 @@
 				continue;
 			}
 			/* findroot command found, try match  */
-			if (strcmp(lp->arg, findroot) != 0) {
+			if (strncmp(lp->arg, strchr(findroot, '_') + 1, strlen(lp->arg)) != 0) {
 				BAM_DPRINTF((D_NOMATCH_FINDROOT,
 				    fcn, findroot, lp->arg));
 				continue;
@@ -7870,6 +7885,7 @@
 		 * For xpv entries, there are two module lines, so we
 		 * do the check twice.
 		 */
+		lp = lp->next;	/* advance to options line */
 		lp = lp->next;	/* advance to module line */
 		if (check_cmd(lp->cmd, MODULE_CMD, lp->arg, module) ||
 		    (((lp = lp->next) != NULL) &&
@@ -7911,6 +7927,7 @@
 	line_t		*tlp;
 	char		linebuf[BAM_MAXLINE];
 	const char	*fcn = "update_boot_entry()";
+	char 		*label;
 
 	/* note: don't match on title, it's updated on upgrade */
 	ent = find_boot_entry(mp, NULL, kernel, findroot, root, module,
@@ -7967,10 +7984,13 @@
 
 	lp->cmd = s_strdup(menu_cmds[FINDROOT_CMD]);
 	lp->sep = s_strdup(menu_cmds[SEP_CMD]);
-	lp->arg = s_strdup(findroot);
+	label = s_strdup(strchr(findroot, '_') + 1);
+	*(strchr(label,',')) = 0;
+	lp->arg = s_strdup(label);
 	(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s",
-	    menu_cmds[FINDROOT_CMD], menu_cmds[SEP_CMD], findroot);
+	    menu_cmds[FINDROOT_CMD], menu_cmds[SEP_CMD], label);
 	lp->line = s_strdup(linebuf);
+	free(label);
 	BAM_DPRINTF((D_ADDING_FINDROOT_LINE, fcn, findroot));
 
 	/* kernel line */
@@ -7978,16 +7998,13 @@
 
 	if (ent->flags & BAM_ENTRY_UPGFSKERNEL) {
 		char		*params = NULL;
+		char		*opts = NULL;
 
-		params = strstr(lp->line, "-s");
-		if (params != NULL)
-			(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s%s",
-			    menu_cmds[KERNEL_DOLLAR_CMD], menu_cmds[SEP_CMD],
-			    kernel, params+2);
-		else
-			(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s",
-			    menu_cmds[KERNEL_DOLLAR_CMD], menu_cmds[SEP_CMD],
-			    kernel);
+		opts = strpbrk(kernel, " \t");
+		*opts++ = '\0';
+		(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s",
+		    menu_cmds[KERNEL_DOLLAR_CMD], menu_cmds[SEP_CMD],
+		    kernel);
 
 		if (lp->cmd != NULL)
 			free(lp->cmd);
@@ -7999,12 +8016,28 @@
 		lp->line = s_strdup(linebuf);
 		ent->flags &= ~BAM_ENTRY_UPGFSKERNEL;
 		BAM_DPRINTF((D_ADDING_KERNEL_DOLLAR, fcn, lp->prev->cmd));
+
+		lp = lp->next;
+		params = strstr(lp->arg, "-s");
+		free(lp->arg);
+		free(lp->line);
+		if (params)
+			(void) snprintf(linebuf, sizeof(linebuf), "%s%s%s -s",
+				lp->cmd, menu_cmds[SEP_CMD],opts);
+		else
+			(void) snprintf(linebuf, sizeof(linebuf), "%s%s%s",
+				lp->cmd, menu_cmds[SEP_CMD],opts);
+		lp->line = s_strdup(linebuf);
+		lp->arg = s_strdup(strchr(linebuf, '=') + 1);
 	}
 
 	if (change_kernel) {
+		char		*opts = NULL;
 		/*
 		 * We're upgrading from multiboot to directboot.
 		 */
+		opts = strpbrk(kernel, " \t");
+		*opts++ = '\0';
 		if (lp->cmd != NULL &&
 		    strcmp(lp->cmd, menu_cmds[KERNEL_CMD]) == 0) {
 			(void) snprintf(linebuf, sizeof (linebuf), "%s%s%s",
@@ -8018,6 +8051,12 @@
 			lp->line = s_strdup(linebuf);
 			lp = lp->next;
 			BAM_DPRINTF((D_ADDING_KERNEL_DOLLAR, fcn, kernel));
+			(void) snprintf(linebuf, sizeof(linebuf), "%s%s%s",
+				lp->cmd, menu_cmds[SEP_CMD],opts);
+			free(lp->arg);
+			free(lp->line);
+			lp->line = s_strdup(linebuf);
+			lp->arg = s_strdup(strchr(linebuf, '=') + 1);
 		}
 		if (lp->cmd != NULL &&
 		    strcmp(lp->cmd, menu_cmds[MODULE_CMD]) == 0) {
@@ -8410,6 +8449,7 @@
 	}
 
 	sign = find_existing_sign("/", osdev, fstype);
+	sign = strchr(sign, '_') + 1;
 	INJECT_ERROR1("REBOOT_SIGN_NULL", sign = NULL);
 	if (sign == NULL) {
 		free(fstype);
@@ -8858,7 +8898,7 @@
 		for (ptr = entryp->start; ptr && ptr != entryp->end;
 		    ptr = ptr->next) {
 			if (strncmp(ptr->cmd, menu_cmds[KERNEL_CMD],
-			    sizeof (menu_cmds[KERNEL_CMD]) - 1) == 0) {
+			    sizeof (menu_cmds[KERNEL_CMD]) - 2) == 0) {
 				kernelp = ptr;
 				break;
 			}
@@ -8946,8 +8986,8 @@
 			new_str_len = (sizeof (DIRECT_BOOT_KERNEL) - 1) +
 			    strlen(old_args) + 2;
 			new_arg = s_calloc(1, new_str_len);
-			(void) snprintf(new_arg, new_str_len, "%s %s",
-			    DIRECT_BOOT_KERNEL, old_args);
+			(void) snprintf(new_arg, new_str_len, "%s",
+			    DIRECT_BOOT_KERNEL);
 			free(kernelp->arg);
 			kernelp->arg = new_arg;
 
@@ -9108,9 +9148,10 @@
 		BAM_DPRINTF((D_GET_SET_KERNEL_REPLACED_KERNEL_SAME_ARG, fcn,
 		    kernelp->arg));
 	} else {
-		new_str_len = old_kernel_len + strlen(path) + 8;
+		kernelp = kernelp->next;
+		new_str_len = strlen(kernelp->arg) + strlen(path) + 8;
 		new_arg = s_calloc(1, new_str_len);
-		(void) strncpy(new_arg, kernelp->arg, old_kernel_len);
+		(void) strncpy(new_arg, kernelp->arg, strlen(kernelp->arg));
 		(void) strlcat(new_arg, " ", new_str_len);
 		(void) strlcat(new_arg, path, new_str_len);
 		free(kernelp->arg);
--- old/bootadm/bootadm.h	2012-08-31 05:08:47.497329891 +0400
+++ new/bootadm/bootadm.h	2012-08-31 05:08:47.522789144 +0400
@@ -126,7 +126,8 @@
 	CHAINLOADER_CMD,
 	ARGS_CMD,
 	FINDROOT_CMD,
-	BOOTFS_CMD
+	BOOTFS_CMD,
+	KERNEL_OPTIONS_CMD,
 } menu_cmd_t;
 
 extern char *menu_cmds[];
@@ -217,7 +218,7 @@
 #define	NEW_HV_ENTRY	"Solaris xVM"
 
 /* ZFS boot option */
-#define	ZFS_BOOT	"-B $ZFS-BOOTFS"
+#define	ZFS_BOOT	"-B $ZFS_BOOTFS"
 
 /* multiboot */
 #define	MULTI_BOOT	"/platform/i86pc/multiboot"
--- old/bootadm/bootadm_hyper.c	2012-08-31 05:08:48.139702554 +0400
+++ new/bootadm/bootadm_hyper.c	2012-08-31 05:08:48.156871361 +0400
@@ -23,6 +23,10 @@
  * Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
  */
 
+/*
+ * Copyright 2012 Daniil Lunev. All rights reserved.
+ */
+
 #include <stdio.h>
 #include <errno.h>
 #include <stdlib.h>
@@ -39,7 +43,7 @@
 #define	METAL_KERNEL_DIR 		"/platform/i86pc/kernel"
 
 #define	BOOTRC_FILE			"/boot/solaris/bootenv.rc"
-#define	ZFS_BOOTSTR			"$ZFS-BOOTFS"
+#define	ZFS_BOOTSTR			"$ZFS_BOOTFS"
 
 #define	BFLAG				"-B"
 #define	DEFAULT_SERIAL			"9600,8,n,1"
@@ -763,8 +767,10 @@
 	char *findroot = NULL;
 	char *bootfs = NULL;
 	char *kernel = NULL;
+	char *opts = NULL;
 	char *mod_kernel = NULL;
 	char *module = NULL;
+	char *tmp = NULL;
 
 	char *kern_path = NULL;
 	char *kern_bargs = NULL;
@@ -841,10 +847,12 @@
 		if (lp->flags == BAM_TITLE) {
 			title = strdupa(lp->arg);
 		} else if (lp->cmd != NULL) {
-			if (strcmp(lp->cmd, "findroot") == 0) {
+			if (strcmp(lp->cmd, "pool_label") == 0) {
 				findroot = strdupa(lp->arg);
-			} else if (strcmp(lp->cmd, "bootfs") == 0) {
+			} else if (strcmp(lp->cmd, "data_set") == 0) {
 				bootfs = strdupa(lp->arg);
+			} else if (strcmp(lp->cmd, "kernel_options") == 0) {
+				opts = strdupa(lp->arg);
 			} else if (strcmp(lp->cmd,
 			    menu_cmds[MODULE_DOLLAR_CMD]) == 0) {
 				module = strdupa(lp->arg);
@@ -866,6 +874,7 @@
 			break;
 	}
 
+	
 	/*
 	 * If findroot, module or kern_path are NULL, the boot entry is
 	 * malformed.
@@ -948,7 +957,10 @@
 	zfslen = (zfs_boot ? (WHITESPC(1) + strlen(ZFS_BOOT)) : 0);
 
 	mod_kernel = alloca(len + zfslen);
-	(void) snprintf(mod_kernel, len, "%s %s", kern_path, kern_path);
+	if (opts)
+		(void) snprintf(mod_kernel, len + strlen(opts) + 1, "%s %s %s", kern_path, kern_path, opts);
+	else
+		(void) snprintf(mod_kernel, len, "%s %s", kern_path, kern_path);
 
 	if (kp_allocated)
 		free(kern_path);
@@ -1062,9 +1074,9 @@
 		if (lp->flags == BAM_TITLE) {
 			title = strdupa(lp->arg);
 		} else if (lp->cmd != NULL) {
-			if (strcmp(lp->cmd, "findroot") == 0) {
+			if (strcmp(lp->cmd, "pool_label") == 0) {
 				findroot = strdupa(lp->arg);
-			} else if (strcmp(lp->cmd, "bootfs") == 0) {
+			} else if (strcmp(lp->cmd, "data_set") == 0) {
 				bootfs = strdupa(lp->arg);
 			} else if (strcmp(lp->cmd,
 			    menu_cmds[MODULE_DOLLAR_CMD]) == 0) {
--- old/grub/Makefile.util.def	2012-08-31 05:08:49.123997809 +0400
+++ new/grub/Makefile.util.def	2012-08-31 05:08:49.186444990 +0400
@@ -304,6 +304,21 @@
 };
 
 program = {
+  name = grub-solarislst2cfg;
+  installdir = sbin;
+  mansection = 8;
+  common = util/grub-solarislst2cfg.c;
+  common = util/ieee1275/ofpath.c;
+  common = grub-core/kern/emu/argp_common.c;
+
+  ldadd = libgrubmods.a;
+  ldadd = libgrubgcry.a;
+  ldadd = libgrubkern.a;
+  ldadd = grub-core/gnulib/libgnu.a;
+  ldadd = '$(LIBINTL) $(LIBDEVMAPPER) $(LIBUTIL) $(LIBZFS) $(LIBNVPAIR) $(LIBGEOM)';
+};
+
+program = {
   name = grub-bios-setup;
   installdir = sbin;
   mansection = 8;
--- old/grub/grub-core/Makefile.core.def	2012-08-31 05:08:49.854539106 +0400
+++ new/grub/grub-core/Makefile.core.def	2012-08-31 05:08:49.890410130 +0400
@@ -1484,6 +1484,16 @@
 };
 
 module = {
+  name = illumos_entries;
+  common = commands/illumos_entries.c;
+};
+
+module = {
+  name = solarislegacy;
+  common = commands/solarislegacy.c;
+};
+
+module = {
   name = part_acorn;
   common = partmap/acorn.c;
 };
--- /dev/null	2012-08-31 05:08:50.000000000 +0400
+++ new/grub/grub-core/commands/illumos_entries.c	2012-08-31 05:08:50.595738459 +0400
@@ -0,0 +1,197 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2012 Daniil Lunev
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/types.h>
+#include <grub/file.h>
+#include <grub/disk.h>
+#include <grub/misc.h>
+#include <grub/err.h>
+#include <grub/dl.h>
+#include <grub/extcmd.h>
+#include <grub/i18n.h>
+#include <grub/normal.h>
+
+#include "menu_managing.c"
+
+GRUB_MOD_LICENSE ("GPLv3+");
+
+static const struct grub_arg_option options[] = {
+  {0, 0, 0, 0, 0, 0}
+};
+
+static const char * globals[] = {
+  "default_entry",
+  "timeout",
+  "serial",
+  "terminal",
+  NULL
+};
+
+static grub_err_t
+get_value(char * buf, char ** value)
+{
+  *value = grub_strchr(buf, '=');
+  if (! *value)
+    return grub_error (GRUB_ERR_INVALID_COMMAND, N_("illumos syntax error"));
+  **value = '\0';
+  ++(*value);
+  return 0;
+}
+
+static int
+check_param(char * param)
+{
+  int i = 0;
+  
+  for (; params_list[i]; ++i)
+    if (!grub_strcmp(param, params_list[i]))
+      return i;
+  
+  return -1;
+}
+
+static int
+check_global(char * param)
+{
+  int i = 0;
+  
+  for (; globals[i]; ++i)
+    if (!grub_strcmp(param, globals[i]))
+      return i;
+  
+  return -1;
+}
+
+static grub_err_t
+parse_config(grub_file_t file, entries * entry_list)
+{
+  char * param;
+  char * value;
+  entries * current_entry = NULL;
+  int param_id = 0;
+  int global_id = 0;
+  grub_err_t err;
+  
+  for(;;) {
+    param = grub_file_getline(file);
+    if (! param)
+      return grub_errno;
+
+    if ((*param == '#') || (*param == ' ') || 
+      (*param == '\t') || (*param == '\n') ||
+      (*param == 0)) {
+      grub_free(param);
+      continue;
+    }
+    global_id = -1;
+      
+    err = get_value(param, &value);
+    if (err)
+      return err;
+
+    param_id = check_param(param);
+    if (param_id < 0) {
+      global_id = check_global(param);
+      if (global_id < 0) {
+        grub_free(param);
+        return grub_error (GRUB_ERR_INVALID_COMMAND, N_("illumos syntax error"));
+      }
+    }
+    if (err)
+      return err;
+    if (!value[0])
+      return grub_error (GRUB_ERR_INVALID_COMMAND, N_("illumos syntax error"));
+    if (global_id < 0) {
+      if (param_id == 0) {
+        current_entry = new_entry(value, entry_list);
+        if (! current_entry) {
+          grub_free(param);
+          return grub_error (GRUB_ERR_OUT_OF_MEMORY, N_("memory can not be allocated"));
+        }
+      } else {
+        grub_strcpy(current_entry->entry_info[param_id], value);
+      }
+    } else {
+      char line[512];
+      switch (global_id) {
+      case 0:
+        grub_env_set("default", value);
+        break;
+      case 1:
+        grub_env_set("timeout", value);
+        break;
+      case 2:
+        grub_strcpy(line, "serial ");
+        grub_strcat(line, value);
+        grub_normal_parse_line(line, NULL);
+        break;
+      case 3:
+        grub_strcpy(line, "terminal_input ");
+        grub_strcat(line, value);
+        grub_strcat(line, "; terminal_output ");
+        grub_strcat(line, value);
+        grub_normal_parse_line(line, NULL);
+        break;
+      default:
+        break;
+      }
+    }
+    grub_free(param);
+  }    
+  return 0;
+}
+
+static grub_err_t
+grub_cmd_illumos_entries (grub_extcmd_context_t ctxt __attribute__ ((unused)), int argc, char **args)
+{
+  grub_file_t file;
+  entries * menu_entries = NULL;
+  
+  if (argc != 1)
+    return grub_error (GRUB_ERR_BAD_ARGUMENT, N_("filename expected"));
+  
+  file = grub_file_open(args[0]);
+  
+  if (!file)
+    return grub_errno;
+    
+  init_entries(&menu_entries);
+  
+  if (parse_config(file, menu_entries) == 0) {
+    add_entries(menu_entries);
+  }  
+  clear_entries(menu_entries);
+  
+  grub_refresh();
+  grub_file_close(file);
+
+  return 0;
+}
+
+static grub_extcmd_t illumos_entries;
+
+GRUB_MOD_INIT(illumos_entries)
+{
+  illumos_entries = grub_register_extcmd ("illumos_entries", grub_cmd_illumos_entries, 0,
+            N_("FILE"), N_("Define an illumos menu entries."), options);
+}
+
+GRUB_MOD_FINI(illumos_entries)
+{
+  grub_unregister_extcmd (illumos_entries);
+}
--- /dev/null	2012-08-31 05:08:50.000000000 +0400
+++ new/grub/grub-core/commands/menu_managing.c	2012-08-31 05:08:50.915580323 +0400
@@ -0,0 +1,200 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2012 Daniil Lunev
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#define VALUE_SIZE 512
+
+typedef struct entries entries;
+struct entries {
+  entries *next;
+  char ** entry_info;
+};
+
+enum param_consts {
+  ENTRY_NAME,
+  POOL_UUID,
+  POOL_LABEL,
+  DATA_SET,
+  KERNEL_PATH,
+  KERNEL_OPTIONS,
+  BA_PATH,
+  DOLLAR_KERNEL_PATH,
+  DOLLAR_BA_PATH,
+};
+
+static const char * params_list[] = {
+  "entry_name",
+  "pool_uuid",
+  "pool_label",
+  "data_set",
+  "kernel_path",
+  "kernel_options",
+  "module",
+  "kernel_path$",
+  "module$",
+  NULL
+};
+
+static grub_err_t
+init_entries(entries ** menu_entries)
+{
+  (*menu_entries) = (entries*) grub_zalloc(sizeof (menu_entries));
+  if (! *menu_entries)
+    return grub_error (GRUB_ERR_OUT_OF_MEMORY, N_("memory can not be allocated"));
+  return 0;
+}
+
+static entries * 
+new_entry(char * name, entries * entry_list)
+{
+  unsigned int i;
+
+  if (entry_list->next)
+    do {
+      entry_list = entry_list->next;
+      if (!grub_strcmp(name, entry_list->entry_info[0]))
+        return entry_list;
+    } while (entry_list->next);
+  entry_list->next = (entries*) grub_zalloc(sizeof(entries));
+  if (! entry_list->next)
+    return NULL;
+  entry_list = entry_list->next;
+  entry_list->entry_info = (char**) grub_zalloc(sizeof(params_list));
+  for (i = 0; i < sizeof(params_list) / sizeof(*params_list); i++) {
+    entry_list->entry_info[i] = (char *) grub_zalloc(VALUE_SIZE);
+    if (! entry_list->entry_info[i]) 
+      return NULL;
+  }
+  grub_strcpy(entry_list->entry_info[0], name);
+  return entry_list;
+}
+
+static void
+clear_entries(entries * entry_list)
+{
+  entries * next;
+  unsigned int i;
+
+  next = entry_list->next;
+  grub_free(entry_list);
+  entry_list = next;
+
+  while (entry_list) {
+    next = entry_list->next;
+    if (entry_list->entry_info) {
+      for (i = 0; i < sizeof(params_list) / sizeof(*params_list); i++)
+        if (entry_list->entry_info[i])
+          grub_free(entry_list->entry_info[i]);
+      grub_free(entry_list->entry_info);
+    }
+    grub_free(entry_list);
+    entry_list = next;
+  }
+}
+
+static grub_err_t
+add_entries(entries * menu_entries)
+{
+  grub_err_t err;
+  char cl1[] = "os";
+  char cl2[] = "illumos";
+  char * class[] = {cl1, cl2, NULL};
+  char * argv[] = { NULL, NULL };
+  char id[512];
+  char * entry_source = NULL;
+  char * data_set;
+  char entry_template[] = 
+    "insmod part_sunpc\n"
+    "insmod part_msdos\n"
+    "insmod zfs\n"
+    "insmod gzio\n"
+    "if cpuid -l ; then\n"
+    "  ISADIR=amd64\n"
+    "else\n"
+    "  ISADIR=\n"
+    "fi\n";
+
+  menu_entries = menu_entries->next;
+  while (menu_entries) {
+    argv[0] = grub_strdup(menu_entries->entry_info[ENTRY_NAME]);
+    if (!argv[0])
+      return grub_error (GRUB_ERR_OUT_OF_MEMORY, N_("memory can not be allocated"));
+    entry_source = (char*) grub_zalloc(2048);
+
+    if (!entry_source)
+      return grub_error (GRUB_ERR_OUT_OF_MEMORY, N_("memory can not be allocated"));
+
+    if (menu_entries->entry_info[DATA_SET][0] != 0)
+      data_set = grub_strchr(menu_entries->entry_info[DATA_SET], '/');
+    else
+      data_set = grub_strdup("$ZFS_DATASET");
+    grub_strcpy(entry_source, entry_template);
+    if (menu_entries->entry_info[POOL_UUID][0]) {
+      grub_strcat(entry_source, "search --no-floppy --zfs-mirror --fs-uuid --set=root ");
+      grub_strcat(entry_source, menu_entries->entry_info[POOL_UUID]);
+    } else {
+      grub_strcat(entry_source, "search --no-floppy --zfs-mirror --label --set=root ");
+      grub_strcat(entry_source, menu_entries->entry_info[POOL_LABEL]);
+    }
+    grub_strcat(entry_source, "\n");
+    grub_strcat(entry_source, "zfs-bootfs ($root)");
+    if (menu_entries->entry_info[DATA_SET][0] != 0) {
+      grub_strcat(entry_source, data_set);
+      grub_strcat(entry_source, " ZFS_BOOTFS\n");
+    } else {
+      grub_strcat(entry_source, "default ZFS_BOOTFS ZFS_DATASET\n");
+    }
+    grub_strcat(entry_source, "multiboot ($root)");
+    if (! menu_entries->entry_info[DOLLAR_KERNEL_PATH][0]) {
+      grub_strcat(entry_source, data_set);
+      grub_strcat(entry_source, "/@");
+      grub_strcat(entry_source, menu_entries->entry_info[KERNEL_PATH]);
+      grub_strcat(entry_source, " ");
+      grub_strcat(entry_source, menu_entries->entry_info[KERNEL_PATH]);
+    } else {
+      grub_strcat(entry_source, menu_entries->entry_info[DOLLAR_KERNEL_PATH]);
+    }
+    grub_strcat(entry_source, " ");
+    grub_strcat(entry_source, menu_entries->entry_info[KERNEL_OPTIONS]);
+    grub_strcat(entry_source, "\n");
+    grub_strcat(entry_source, "module ($root)");
+    if (! menu_entries->entry_info[DOLLAR_KERNEL_PATH][0]) {
+      grub_strcat(entry_source, data_set);
+      grub_strcat(entry_source, "/@");
+      grub_strcat(entry_source, menu_entries->entry_info[BA_PATH]);
+      grub_strcat(entry_source, " ");
+      grub_strcat(entry_source, menu_entries->entry_info[BA_PATH]);
+    } else {
+      grub_strcat(entry_source, menu_entries->entry_info[DOLLAR_BA_PATH]);
+    }
+
+    grub_strcpy(id, argv[0]);
+    grub_strcat(id, "-");
+    grub_strcat(id, menu_entries->entry_info[POOL_UUID]);
+
+    err = grub_normal_add_menu_entry (2, (const char **) argv, class, id,
+                NULL,  NULL,  NULL, entry_source, 0);
+
+    if (err)
+      return err;
+    
+    grub_free(argv[0]);
+    menu_entries = menu_entries->next;
+  }
+  grub_free(entry_source);
+  return 0;
+}
--- old/grub/grub-core/commands/search.c	2012-08-31 05:08:51.218990708 +0400
+++ new/grub/grub-core/commands/search.c	2012-08-31 05:08:51.245945407 +0400
@@ -22,6 +22,7 @@
 #include <grub/mm.h>
 #include <grub/err.h>
 #include <grub/dl.h>
+#include <grub/zfs/zfs.h>
 #include <grub/device.h>
 #include <grub/file.h>
 #include <grub/env.h>
@@ -44,10 +45,11 @@
 
 void
 FUNC_NAME (const char *key, const char *var, int no_floppy,
-	   char **hints, unsigned nhints)
+	   char **hints, unsigned nhints, int mirror)
 {
   int count = 0;
   int is_cache = 0;
+  grub_uint64_t txg = 0;
   grub_fs_autoload_hook_t saved_autoload;
 
   auto int iterate_device (const char *name);
@@ -148,14 +150,35 @@
     if (found)
       {
 	count++;
-	if (var)
-	  grub_env_set (var, name);
-	else
+	if (var) {
+          if (! mirror) {
+	    grub_env_set (var, name);
+          } else {
+            grub_uint64_t tmp_txg = 0;
+            char * nvlist = NULL;
+            grub_device_t dev = grub_device_open (name);
+            if (! dev) {
+              grub_errno = GRUB_ERR_BAD_DEVICE;
+              return 0;
+            }
+            grub_errno = grub_zfs_fetch_nvlist (dev, &nvlist);
+            grub_device_close (dev);
+            if (grub_errno)
+              return 0;
+            grub_zfs_nvlist_lookup_uint64 (nvlist, ZPOOL_CONFIG_POOL_TXG, &tmp_txg);
+            if (tmp_txg > txg) {
+	      grub_env_set (var, name);
+              txg = tmp_txg;
+            }
+            grub_free (nvlist);
+          }
+	} else {
 	  grub_printf (" %s", name);
+        }
       }
 
     grub_errno = GRUB_ERR_NONE;
-    return (found && var);
+    return (found && var && !mirror);
   }
 
   auto int part_hook (grub_disk_t disk, const grub_partition_t partition);
@@ -280,7 +303,7 @@
     return grub_error (GRUB_ERR_BAD_ARGUMENT, N_("one argument expected"));
 
   FUNC_NAME (args[0], argc == 1 ? 0 : args[1], 0, (args + 2),
-	     argc > 2 ? argc - 2 : 0);
+	     argc > 2 ? argc - 2 : 0, 0);
 
   return grub_errno;
 }
--- old/grub/grub-core/commands/search_wrap.c	2012-08-31 05:08:51.868877048 +0400
+++ new/grub/grub-core/commands/search_wrap.c	2012-08-31 05:08:51.884072587 +0400
@@ -63,6 +63,7 @@
      N_("First try the device HINT if currently running on ARC."
 	" If HINT ends in comma, also try subpartitions"),
      N_("HINT"), ARG_TYPE_STRING},
+    {"zfs-mirror", 'z', 0, N_("Handle zfs-mirror disk"), 0, 0},
     {0, 0, 0, 0, 0, 0}
   };
 
@@ -79,6 +80,7 @@
     SEARCH_HINT_BAREMETAL,
     SEARCH_HINT_EFI,
     SEARCH_HINT_ARC,
+    SEARCH_ZFS_MIRROR,
  };
 
 static grub_err_t
@@ -89,6 +91,7 @@
   const char *id = 0;
   int i = 0, j = 0, nhints = 0;
   char **hints = NULL;
+  int mirror_mode = 0;
 
   if (state[SEARCH_HINT].set)
     for (i = 0; state[SEARCH_HINT].args[i]; i++)
@@ -177,15 +180,18 @@
   else
     return grub_error (GRUB_ERR_BAD_ARGUMENT, N_("one argument expected"));
 
+  if (state[SEARCH_ZFS_MIRROR].set)
+    mirror_mode = 1;
+
   if (state[SEARCH_LABEL].set)
     grub_search_label (id, var, state[SEARCH_NO_FLOPPY].set, 
-		       hints, nhints);
+		       hints, nhints, mirror_mode);
   else if (state[SEARCH_FS_UUID].set)
     grub_search_fs_uuid (id, var, state[SEARCH_NO_FLOPPY].set,
-			 hints, nhints);
+			 hints, nhints, mirror_mode);
   else if (state[SEARCH_FILE].set)
     grub_search_fs_file (id, var, state[SEARCH_NO_FLOPPY].set, 
-			 hints, nhints);
+			 hints, nhints, mirror_mode);
   else
     return grub_error (GRUB_ERR_INVALID_COMMAND, "unspecified search type");
 
